<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EkSecenekGrup StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EkSecenekGrup
 * @subpackage Structs
 */
class EkSecenekGrup extends AbstractStructBase
{
    /**
     * The Degerler
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfEkSecenekDeger
     */
    public $Degerler;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Tanim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tanim;
    /**
     * The Tur
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Tur;
    /**
     * Constructor method for EkSecenekGrup
     * @uses EkSecenekGrup::setDegerler()
     * @uses EkSecenekGrup::setID()
     * @uses EkSecenekGrup::setTanim()
     * @uses EkSecenekGrup::setTur()
     * @param \ArrayType\ArrayOfEkSecenekDeger $degerler
     * @param int $iD
     * @param string $tanim
     * @param string $tur
     */
    public function __construct(\ArrayType\ArrayOfEkSecenekDeger $degerler = null, $iD = null, $tanim = null, $tur = null)
    {
        $this
            ->setDegerler($degerler)
            ->setID($iD)
            ->setTanim($tanim)
            ->setTur($tur);
    }
    /**
     * Get Degerler value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfEkSecenekDeger|null
     */
    public function getDegerler()
    {
        return isset($this->Degerler) ? $this->Degerler : null;
    }
    /**
     * Set Degerler value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfEkSecenekDeger $degerler
     * @return \StructType\EkSecenekGrup
     */
    public function setDegerler(\ArrayType\ArrayOfEkSecenekDeger $degerler = null)
    {
        if (is_null($degerler) || (is_array($degerler) && empty($degerler))) {
            unset($this->Degerler);
        } else {
            $this->Degerler = $degerler;
        }
        return $this;
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\EkSecenekGrup
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !(is_int($iD) || ctype_digit($iD))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Tanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTanim()
    {
        return isset($this->Tanim) ? $this->Tanim : null;
    }
    /**
     * Set Tanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tanim
     * @return \StructType\EkSecenekGrup
     */
    public function setTanim($tanim = null)
    {
        // validation for constraint: string
        if (!is_null($tanim) && !is_string($tanim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tanim, true), gettype($tanim)), __LINE__);
        }
        if (is_null($tanim) || (is_array($tanim) && empty($tanim))) {
            unset($this->Tanim);
        } else {
            $this->Tanim = $tanim;
        }
        return $this;
    }
    /**
     * Get Tur value
     * @return string|null
     */
    public function getTur()
    {
        return $this->Tur;
    }
    /**
     * Set Tur value
     * @uses \EnumType\BLEnums_VaryasyonTuru::valueIsValid()
     * @uses \EnumType\BLEnums_VaryasyonTuru::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tur
     * @return \StructType\EkSecenekGrup
     */
    public function setTur($tur = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\BLEnums_VaryasyonTuru::valueIsValid($tur)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\BLEnums_VaryasyonTuru', is_array($tur) ? implode(', ', $tur) : var_export($tur, true), implode(', ', \EnumType\BLEnums_VaryasyonTuru::getValidValues())), __LINE__);
        }
        $this->Tur = $tur;
        return $this;
    }
}
